Index: LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5140)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/cv3_routines.F90	(revision 5141)
@@ -517,50 +510,50 @@
 
   DO i = 1, len
-    cpnk(i) = cpd*(1.0-qnk(i)) + cpv*qnk(i)
-    hnk(i) = gz(i, 1) + cpnk(i)*tnk(i)
-  END DO
-
-! -------------------------------------------------------------------
-! --- Check whether parcel level temperature and specific humidity
-! --- are reasonable
-! -------------------------------------------------------------------
+    cpnk(i) = cpd * (1.0 - qnk(i)) + cpv * qnk(i)
+    hnk(i) = gz(i, 1) + cpnk(i) * tnk(i)
+  END DO
+
+  ! -------------------------------------------------------------------
+  ! --- Check whether parcel level temperature and specific humidity
+  ! --- are reasonable
+  ! -------------------------------------------------------------------
   IF (cv_flag_feed == 1) THEN
     DO i = 1, len
       IF (((tnk(i)<250.0)                       .OR.  &
-           (qnk(i)<=0.0))                       .AND. &
-          (iflag(i)==0)) iflag(i) = 7
+              (qnk(i)<=0.0))                       .AND. &
+              (iflag(i)==0)) iflag(i) = 7
     END DO
   ELSEIF (cv_flag_feed >= 2) THEN
-! --- and demand that LCL be high enough
+    ! --- and demand that LCL be high enough
     DO i = 1, len
       IF (((tnk(i)<250.0)                       .OR.  &
-           (qnk(i)<=0.0)                        .OR.  &
-           (plcl(i)>min(0.99*ph(i,1),ph(i,3)))) .AND. &
-          (iflag(i)==0)) iflag(i) = 7
+              (qnk(i)<=0.0)                        .OR.  &
+              (plcl(i)>min(0.99 * ph(i, 1), ph(i, 3)))) .AND. &
+              (iflag(i)==0)) iflag(i) = 7
     END DO
   ENDIF
   IF (prt_level >= 10) THEN
-    print *,'cv3_feed : iflag(1), pfeed(1), plcl(1), wghti(1,k) ', &
-                        iflag(1), pfeed(1), plcl(1), (wghti(1,k),k=1,10)
+    print *, 'cv3_feed : iflag(1), pfeed(1), plcl(1), wghti(1,k) ', &
+            iflag(1), pfeed(1), plcl(1), (wghti(1, k), k = 1, 10)
   ENDIF
 
-! -------------------------------------------------------------------
-! --- Calculate first level above lcl (=icb)
-! -------------------------------------------------------------------
-
-!@      do 270 i=1,len
-!@       icb(i)=nlm
-!@ 270  continue
-!@c
-!@      do 290 k=minorig,nl
-!@        do 280 i=1,len
-!@          if((k.ge.(nk(i)+1)).AND.(p(i,k).lt.plcl(i)))
-!@     &    icb(i)=min(icb(i),k)
-!@ 280    continue
-!@ 290  continue
-!@c
-!@      do 300 i=1,len
-!@        if((icb(i).ge.nlm).AND.(iflag(i).EQ.0))iflag(i)=9
-!@ 300  continue
+  ! -------------------------------------------------------------------
+  ! --- Calculate first level above lcl (=icb)
+  ! -------------------------------------------------------------------
+
+  !@      do 270 i=1,len
+  !@       icb(i)=nlm
+  !@ 270  continue
+  !@c
+  !@      do 290 k=minorig,nl
+  !@        do 280 i=1,len
+  !@          if((k.ge.(nk(i)+1)).AND.(p(i,k).lt.plcl(i)))
+  !@     &    icb(i)=min(icb(i),k)
+  !@ 280    continue
+  !@ 290  continue
+  !@c
+  !@      do 300 i=1,len
+  !@        if((icb(i).ge.nlm).AND.(iflag(i).EQ.0))iflag(i)=9
+  !@ 300  continue
 
   DO i = 1, len
@@ -568,20 +561,20 @@
   END DO
 
-! la modification consiste a comparer plcl a ph et non a p:
-! icb est defini par :  ph(icb)<plcl<ph(icb-1)
-!@      do 290 k=minorig,nl
+  ! la modification consiste a comparer plcl a ph et non a p:
+  ! icb est defini par :  ph(icb)<plcl<ph(icb-1)
+  !@      do 290 k=minorig,nl
   DO k = 3, nl - 1 ! modif pour que icb soit sup/egal a 2
     DO i = 1, len
-      IF (ph(i,k)<plcl(i)) icb(i) = min(icb(i), k)
-    END DO
-  END DO
-
-
-! PRINT*,'icb dans cv3_feed '
-! WRITE(*,'(64i2)') icb(2:len-1)
-! CALL dump2d(64,43,'plcl dans cv3_feed ',plcl(2:len-1))
+      IF (ph(i, k)<plcl(i)) icb(i) = min(icb(i), k)
+    END DO
+  END DO
+
+
+  ! PRINT*,'icb dans cv3_feed '
+  ! WRITE(*,'(64i2)') icb(2:len-1)
+  ! CALL dump2d(64,43,'plcl dans cv3_feed ',plcl(2:len-1))
 
   DO i = 1, len
-!@        if((icb(i).ge.nlm).AND.(iflag(i).EQ.0))iflag(i)=9
+    !@        if((icb(i).ge.nlm).AND.(iflag(i).EQ.0))iflag(i)=9
     IF ((icb(i)==nlm) .AND. (iflag(i)==0)) iflag(i) = 9
   END DO
@@ -591,48 +584,47 @@
   END DO
 
-! Compute icbmax.
+  ! Compute icbmax.
 
   icbmax = 2
   DO i = 1, len
-!!        icbmax=max(icbmax,icb(i))
+    !!        icbmax=max(icbmax,icb(i))
     IF (iflag(i)<7) icbmax = max(icbmax, icb(i))     ! sb Jun7th02
   END DO
 
-
 END SUBROUTINE cv3_feed
 
 SUBROUTINE cv3_undilute1(len, nd, t, qs, gz, plcl, p, icb, tnk, qnk, gznk, &
-                         tp, tvp, clw, icbs)
+        tp, tvp, clw, icbs)
+  USE lmdz_cvthermo
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
-! ----------------------------------------------------------------
-! Equivalent de TLIFT entre NK et ICB+1 inclus
-
-! Differences with convect4:
-!    - specify plcl in input
-!    - icbs is the first level above LCL (may differ from icb)
-!    - in the iterations, used x(icbs) instead x(icb)
-!    - many minor differences in the iterations
-!    - tvp is computed in only one time
-!    - icbs: first level above Plcl (IMIN de TLIFT) in output
-!    - if icbs=icb, compute also tp(icb+1),tvp(icb+1) & clw(icb+1)
-! ----------------------------------------------------------------
-
-  include "cvthermo.h"
-  include "cv3param.h"
-
-! inputs:
-  INTEGER, INTENT (IN)                              :: len, nd
-  INTEGER, DIMENSION (len), INTENT (IN)             :: icb
-  REAL, DIMENSION (len, nd), INTENT (IN)            :: t, qs, gz
-  REAL, DIMENSION (len), INTENT (IN)                :: tnk, qnk, gznk
-  REAL, DIMENSION (len, nd), INTENT (IN)            :: p
-  REAL, DIMENSION (len), INTENT (IN)                :: plcl              ! convect3
-
-! outputs:
-  INTEGER, DIMENSION (len), INTENT (OUT)            :: icbs
-  REAL, DIMENSION (len, nd), INTENT (OUT)           :: tp, tvp, clw
-
-! local variables:
+  ! ----------------------------------------------------------------
+  ! Equivalent de TLIFT entre NK et ICB+1 inclus
+
+  ! Differences with convect4:
+  !    - specify plcl in input
+  !    - icbs is the first level above LCL (may differ from icb)
+  !    - in the iterations, used x(icbs) instead x(icb)
+  !    - many minor differences in the iterations
+  !    - tvp is computed in only one time
+  !    - icbs: first level above Plcl (IMIN de TLIFT) in output
+  !    - if icbs=icb, compute also tp(icb+1),tvp(icb+1) & clw(icb+1)
+  ! ----------------------------------------------------------------
+
+  ! inputs:
+  INTEGER, INTENT (IN) :: len, nd
+  INTEGER, DIMENSION (len), INTENT (IN) :: icb
+  REAL, DIMENSION (len, nd), INTENT (IN) :: t, qs, gz
+  REAL, DIMENSION (len), INTENT (IN) :: tnk, qnk, gznk
+  REAL, DIMENSION (len, nd), INTENT (IN) :: p
+  REAL, DIMENSION (len), INTENT (IN) :: plcl              ! convect3
+
+  ! outputs:
+  INTEGER, DIMENSION (len), INTENT (OUT) :: icbs
+  REAL, DIMENSION (len, nd), INTENT (OUT) :: tp, tvp, clw
+
+  ! local variables:
   INTEGER i, k
   INTEGER icb1(len), icbsmax2                                            ! convect3
@@ -643,29 +635,29 @@
   REAL cpinv(len)                                                        ! convect3
 
-! -------------------------------------------------------------------
-! --- Calculates the lifted parcel virtual temperature at nk,
-! --- the actual temperature, and the adiabatic
-! --- liquid water content. The procedure is to solve the equation.
-!     cp*tp+L*qp+phi=cp*tnk+L*qnk+gznk.
-! -------------------------------------------------------------------
-
-
-! ***  Calculate certain parcel quantities, including static energy   ***
+  ! -------------------------------------------------------------------
+  ! --- Calculates the lifted parcel virtual temperature at nk,
+  ! --- the actual temperature, and the adiabatic
+  ! --- liquid water content. The procedure is to solve the equation.
+  !     cp*tp+L*qp+phi=cp*tnk+L*qnk+gznk.
+  ! -------------------------------------------------------------------
+
+
+  ! ***  Calculate certain parcel quantities, including static energy   ***
 
   DO i = 1, len
-    ah0(i) = (cpd*(1.-qnk(i))+cl*qnk(i))*tnk(i) + qnk(i)*(lv0-clmcpv*(tnk(i)-273.15)) + gznk(i)
-    cpp(i) = cpd*(1.-qnk(i)) + qnk(i)*cpv
-    cpinv(i) = 1./cpp(i)
-  END DO
-
-! ***   Calculate lifted parcel quantities below cloud base   ***
+    ah0(i) = (cpd * (1. - qnk(i)) + cl * qnk(i)) * tnk(i) + qnk(i) * (lv0 - clmcpv * (tnk(i) - 273.15)) + gznk(i)
+    cpp(i) = cpd * (1. - qnk(i)) + qnk(i) * cpv
+    cpinv(i) = 1. / cpp(i)
+  END DO
+
+  ! ***   Calculate lifted parcel quantities below cloud base   ***
 
   DO i = 1, len                                           !convect3
     icb1(i) = min(max(icb(i), 2), nl)
-! if icb is below LCL, start loop at ICB+1:
-! (icbs est le premier niveau au-dessus du LCL)
+    ! if icb is below LCL, start loop at ICB+1:
+    ! (icbs est le premier niveau au-dessus du LCL)
     icbs(i) = icb1(i)                                     !convect3
-    IF (plcl(i)<p(i,icb1(i))) THEN
-      icbs(i) = min(icbs(i)+1, nl)                        !convect3
+    IF (plcl(i)<p(i, icb1(i))) THEN
+      icbs(i) = min(icbs(i) + 1, nl)                        !convect3
     END IF
   END DO                                                  !convect3
@@ -678,6 +670,6 @@
 
 
-! Re-compute icbsmax (icbsmax2):                          !convect3
-!                                                         !convect3
+  ! Re-compute icbsmax (icbsmax2):                          !convect3
+  !                                                         !convect3
   icbsmax2 = 2                                            !convect3
   DO i = 1, len                                           !convect3
@@ -685,5 +677,5 @@
   END DO                                                  !convect3
 
-! initialization outputs:
+  ! initialization outputs:
 
   DO k = 1, icbsmax2                                      ! convect3
@@ -695,112 +687,111 @@
   END DO                                                  ! convect3
 
-! tp and tvp below cloud base:
+  ! tp and tvp below cloud base:
 
   DO k = minorig, icbsmax2 - 1
     DO i = 1, len
-      tp(i, k) = tnk(i) - (gz(i,k)-gznk(i))*cpinv(i)
-      tvp(i, k) = tp(i, k)*(1.+qnk(i)/eps-qnk(i))        !whole thing (convect3)
-    END DO
-  END DO
-
-! ***  Find lifted parcel quantities above cloud base    ***
+      tp(i, k) = tnk(i) - (gz(i, k) - gznk(i)) * cpinv(i)
+      tvp(i, k) = tp(i, k) * (1. + qnk(i) / eps - qnk(i))        !whole thing (convect3)
+    END DO
+  END DO
+
+  ! ***  Find lifted parcel quantities above cloud base    ***
 
   DO i = 1, len
     tg = ticb(i)
-! ori         qg=qs(i,icb(i))
+    ! ori         qg=qs(i,icb(i))
     qg = qsicb(i) ! convect3
-! debug         alv=lv0-clmcpv*(ticb(i)-t0)
-    alv = lv0 - clmcpv*(ticb(i)-273.15)
-
-! First iteration.
-
-! ori          s=cpd+alv*alv*qg/(rrv*ticb(i)*ticb(i))
-    s = cpd*(1.-qnk(i)) + cl*qnk(i) + &                   ! convect3
-        alv*alv*qg/(rrv*ticb(i)*ticb(i))                  ! convect3
-    s = 1./s
-! ori          ahg=cpd*tg+(cl-cpd)*qnk(i)*ticb(i)+alv*qg+gzicb(i)
-    ahg = cpd*tg + (cl-cpd)*qnk(i)*tg + alv*qg + gzicb(i) ! convect3
-    tg = tg + s*(ah0(i)-ahg)
-! ori          tg=max(tg,35.0)
-! debug          tc=tg-t0
+    ! debug         alv=lv0-clmcpv*(ticb(i)-t0)
+    alv = lv0 - clmcpv * (ticb(i) - 273.15)
+
+    ! First iteration.
+
+    ! ori          s=cpd+alv*alv*qg/(rrv*ticb(i)*ticb(i))
+    s = cpd * (1. - qnk(i)) + cl * qnk(i) + &                   ! convect3
+            alv * alv * qg / (rrv * ticb(i) * ticb(i))                  ! convect3
+    s = 1. / s
+    ! ori          ahg=cpd*tg+(cl-cpd)*qnk(i)*ticb(i)+alv*qg+gzicb(i)
+    ahg = cpd * tg + (cl - cpd) * qnk(i) * tg + alv * qg + gzicb(i) ! convect3
+    tg = tg + s * (ah0(i) - ahg)
+    ! ori          tg=max(tg,35.0)
+    ! debug          tc=tg-t0
     tc = tg - 273.15
     denom = 243.5 + tc
     denom = max(denom, 1.0) ! convect3
-! ori          IF(tc.ge.0.0)THEN
-    es = 6.112*exp(17.67*tc/denom)
-! ori          else
-! ori           es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
-! ori          endif
-! ori          qg=eps*es/(p(i,icb(i))-es*(1.-eps))
-    qg = eps*es/(p(i,icbs(i))-es*(1.-eps))
-
-! Second iteration.
-
-
-! ori          s=cpd+alv*alv*qg/(rrv*ticb(i)*ticb(i))
-! ori          s=1./s
-! ori          ahg=cpd*tg+(cl-cpd)*qnk(i)*ticb(i)+alv*qg+gzicb(i)
-    ahg = cpd*tg + (cl-cpd)*qnk(i)*tg + alv*qg + gzicb(i) ! convect3
-    tg = tg + s*(ah0(i)-ahg)
-! ori          tg=max(tg,35.0)
-! debug          tc=tg-t0
+    ! ori          IF(tc.ge.0.0)THEN
+    es = 6.112 * exp(17.67 * tc / denom)
+    ! ori          else
+    ! ori           es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
+    ! ori          endif
+    ! ori          qg=eps*es/(p(i,icb(i))-es*(1.-eps))
+    qg = eps * es / (p(i, icbs(i)) - es * (1. - eps))
+
+    ! Second iteration.
+
+
+    ! ori          s=cpd+alv*alv*qg/(rrv*ticb(i)*ticb(i))
+    ! ori          s=1./s
+    ! ori          ahg=cpd*tg+(cl-cpd)*qnk(i)*ticb(i)+alv*qg+gzicb(i)
+    ahg = cpd * tg + (cl - cpd) * qnk(i) * tg + alv * qg + gzicb(i) ! convect3
+    tg = tg + s * (ah0(i) - ahg)
+    ! ori          tg=max(tg,35.0)
+    ! debug          tc=tg-t0
     tc = tg - 273.15
     denom = 243.5 + tc
     denom = max(denom, 1.0)                               ! convect3
-! ori          IF(tc.ge.0.0)THEN
-    es = 6.112*exp(17.67*tc/denom)
-! ori          else
-! ori           es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
-! ori          end if
-! ori          qg=eps*es/(p(i,icb(i))-es*(1.-eps))
-    qg = eps*es/(p(i,icbs(i))-es*(1.-eps))
-
-    alv = lv0 - clmcpv*(ticb(i)-273.15)
-
-! ori c approximation here:
-! ori         tp(i,icb(i))=(ah0(i)-(cl-cpd)*qnk(i)*ticb(i)
-! ori     &   -gz(i,icb(i))-alv*qg)/cpd
-
-! convect3: no approximation:
-    tp(i, icbs(i)) = (ah0(i)-gz(i,icbs(i))-alv*qg)/(cpd+(cl-cpd)*qnk(i))
-
-! ori         clw(i,icb(i))=qnk(i)-qg
-! ori         clw(i,icb(i))=max(0.0,clw(i,icb(i)))
+    ! ori          IF(tc.ge.0.0)THEN
+    es = 6.112 * exp(17.67 * tc / denom)
+    ! ori          else
+    ! ori           es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
+    ! ori          end if
+    ! ori          qg=eps*es/(p(i,icb(i))-es*(1.-eps))
+    qg = eps * es / (p(i, icbs(i)) - es * (1. - eps))
+
+    alv = lv0 - clmcpv * (ticb(i) - 273.15)
+
+    ! ori c approximation here:
+    ! ori         tp(i,icb(i))=(ah0(i)-(cl-cpd)*qnk(i)*ticb(i)
+    ! ori     &   -gz(i,icb(i))-alv*qg)/cpd
+
+    ! convect3: no approximation:
+    tp(i, icbs(i)) = (ah0(i) - gz(i, icbs(i)) - alv * qg) / (cpd + (cl - cpd) * qnk(i))
+
+    ! ori         clw(i,icb(i))=qnk(i)-qg
+    ! ori         clw(i,icb(i))=max(0.0,clw(i,icb(i)))
     clw(i, icbs(i)) = qnk(i) - qg
-    clw(i, icbs(i)) = max(0.0, clw(i,icbs(i)))
-
-    rg = qg/(1.-qnk(i))
-! ori         tvp(i,icb(i))=tp(i,icb(i))*(1.+rg*epsi)
-! convect3: (qg utilise au lieu du vrai mixing ratio rg)
-    tvp(i, icbs(i)) = tp(i, icbs(i))*(1.+qg/eps-qnk(i))   !whole thing
-
-  END DO
-
-! ori      do 380 k=minorig,icbsmax2
-! ori       do 370 i=1,len
-! ori         tvp(i,k)=tvp(i,k)-tp(i,k)*qnk(i)
-! ori 370   continue
-! ori 380  continue
-
-
-! -- The following is only for convect3:
-
-! * icbs is the first level above the LCL:
-! if plcl<p(icb), then icbs=icb+1
-! if plcl>p(icb), then icbs=icb
-
-! * the routine above computes tvp from minorig to icbs (included).
-
-! * to compute buoybase (in cv3_trigger.F), both tvp(icb) and tvp(icb+1)
-! must be known. This is the case if icbs=icb+1, but not if icbs=icb.
-
-! * therefore, in the case icbs=icb, we compute tvp at level icb+1
-! (tvp at other levels will be computed in cv3_undilute2.F)
-
+    clw(i, icbs(i)) = max(0.0, clw(i, icbs(i)))
+
+    rg = qg / (1. - qnk(i))
+    ! ori         tvp(i,icb(i))=tp(i,icb(i))*(1.+rg*epsi)
+    ! convect3: (qg utilise au lieu du vrai mixing ratio rg)
+    tvp(i, icbs(i)) = tp(i, icbs(i)) * (1. + qg / eps - qnk(i))   !whole thing
+
+  END DO
+
+  ! ori      do 380 k=minorig,icbsmax2
+  ! ori       do 370 i=1,len
+  ! ori         tvp(i,k)=tvp(i,k)-tp(i,k)*qnk(i)
+  ! ori 370   continue
+  ! ori 380  continue
+
+
+  ! -- The following is only for convect3:
+
+  ! * icbs is the first level above the LCL:
+  ! if plcl<p(icb), then icbs=icb+1
+  ! if plcl>p(icb), then icbs=icb
+
+  ! * the routine above computes tvp from minorig to icbs (included).
+
+  ! * to compute buoybase (in cv3_trigger.F), both tvp(icb) and tvp(icb+1)
+  ! must be known. This is the case if icbs=icb+1, but not if icbs=icb.
+
+  ! * therefore, in the case icbs=icb, we compute tvp at level icb+1
+  ! (tvp at other levels will be computed in cv3_undilute2.F)
 
   DO i = 1, len
-    ticb(i) = t(i, icb(i)+1)
-    gzicb(i) = gz(i, icb(i)+1)
-    qsicb(i) = qs(i, icb(i)+1)
+    ticb(i) = t(i, icb(i) + 1)
+    gzicb(i) = gz(i, icb(i) + 1)
+    qsicb(i) = qs(i, icb(i) + 1)
   END DO
 
@@ -808,96 +799,95 @@
     tg = ticb(i)
     qg = qsicb(i) ! convect3
-! debug         alv=lv0-clmcpv*(ticb(i)-t0)
-    alv = lv0 - clmcpv*(ticb(i)-273.15)
-
-! First iteration.
-
-! ori          s=cpd+alv*alv*qg/(rrv*ticb(i)*ticb(i))
-    s = cpd*(1.-qnk(i)) + cl*qnk(i) &                         ! convect3
-      +alv*alv*qg/(rrv*ticb(i)*ticb(i))                       ! convect3
-    s = 1./s
-! ori          ahg=cpd*tg+(cl-cpd)*qnk(i)*ticb(i)+alv*qg+gzicb(i)
-    ahg = cpd*tg + (cl-cpd)*qnk(i)*tg + alv*qg + gzicb(i)     ! convect3
-    tg = tg + s*(ah0(i)-ahg)
-! ori          tg=max(tg,35.0)
-! debug          tc=tg-t0
+    ! debug         alv=lv0-clmcpv*(ticb(i)-t0)
+    alv = lv0 - clmcpv * (ticb(i) - 273.15)
+
+    ! First iteration.
+
+    ! ori          s=cpd+alv*alv*qg/(rrv*ticb(i)*ticb(i))
+    s = cpd * (1. - qnk(i)) + cl * qnk(i) &                         ! convect3
+            + alv * alv * qg / (rrv * ticb(i) * ticb(i))                       ! convect3
+    s = 1. / s
+    ! ori          ahg=cpd*tg+(cl-cpd)*qnk(i)*ticb(i)+alv*qg+gzicb(i)
+    ahg = cpd * tg + (cl - cpd) * qnk(i) * tg + alv * qg + gzicb(i)     ! convect3
+    tg = tg + s * (ah0(i) - ahg)
+    ! ori          tg=max(tg,35.0)
+    ! debug          tc=tg-t0
     tc = tg - 273.15
     denom = 243.5 + tc
     denom = max(denom, 1.0)                                   ! convect3
-! ori          IF(tc.ge.0.0)THEN
-    es = 6.112*exp(17.67*tc/denom)
-! ori          else
-! ori           es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
-! ori          endif
-! ori          qg=eps*es/(p(i,icb(i))-es*(1.-eps))
-    qg = eps*es/(p(i,icb(i)+1)-es*(1.-eps))
-
-! Second iteration.
-
-
-! ori          s=cpd+alv*alv*qg/(rrv*ticb(i)*ticb(i))
-! ori          s=1./s
-! ori          ahg=cpd*tg+(cl-cpd)*qnk(i)*ticb(i)+alv*qg+gzicb(i)
-    ahg = cpd*tg + (cl-cpd)*qnk(i)*tg + alv*qg + gzicb(i)     ! convect3
-    tg = tg + s*(ah0(i)-ahg)
-! ori          tg=max(tg,35.0)
-! debug          tc=tg-t0
+    ! ori          IF(tc.ge.0.0)THEN
+    es = 6.112 * exp(17.67 * tc / denom)
+    ! ori          else
+    ! ori           es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
+    ! ori          endif
+    ! ori          qg=eps*es/(p(i,icb(i))-es*(1.-eps))
+    qg = eps * es / (p(i, icb(i) + 1) - es * (1. - eps))
+
+    ! Second iteration.
+
+
+    ! ori          s=cpd+alv*alv*qg/(rrv*ticb(i)*ticb(i))
+    ! ori          s=1./s
+    ! ori          ahg=cpd*tg+(cl-cpd)*qnk(i)*ticb(i)+alv*qg+gzicb(i)
+    ahg = cpd * tg + (cl - cpd) * qnk(i) * tg + alv * qg + gzicb(i)     ! convect3
+    tg = tg + s * (ah0(i) - ahg)
+    ! ori          tg=max(tg,35.0)
+    ! debug          tc=tg-t0
     tc = tg - 273.15
     denom = 243.5 + tc
     denom = max(denom, 1.0)                                   ! convect3
-! ori          IF(tc.ge.0.0)THEN
-    es = 6.112*exp(17.67*tc/denom)
-! ori          else
-! ori           es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
-! ori          end if
-! ori          qg=eps*es/(p(i,icb(i))-es*(1.-eps))
-    qg = eps*es/(p(i,icb(i)+1)-es*(1.-eps))
-
-    alv = lv0 - clmcpv*(ticb(i)-273.15)
-
-! ori c approximation here:
-! ori         tp(i,icb(i))=(ah0(i)-(cl-cpd)*qnk(i)*ticb(i)
-! ori     &   -gz(i,icb(i))-alv*qg)/cpd
-
-! convect3: no approximation:
-    tp(i, icb(i)+1) = (ah0(i)-gz(i,icb(i)+1)-alv*qg)/(cpd+(cl-cpd)*qnk(i))
-
-! ori         clw(i,icb(i))=qnk(i)-qg
-! ori         clw(i,icb(i))=max(0.0,clw(i,icb(i)))
-    clw(i, icb(i)+1) = qnk(i) - qg
-    clw(i, icb(i)+1) = max(0.0, clw(i,icb(i)+1))
-
-    rg = qg/(1.-qnk(i))
-! ori         tvp(i,icb(i))=tp(i,icb(i))*(1.+rg*epsi)
-! convect3: (qg utilise au lieu du vrai mixing ratio rg)
-    tvp(i, icb(i)+1) = tp(i, icb(i)+1)*(1.+qg/eps-qnk(i))     !whole thing
-
-  END DO
-
+    ! ori          IF(tc.ge.0.0)THEN
+    es = 6.112 * exp(17.67 * tc / denom)
+    ! ori          else
+    ! ori           es=exp(23.33086-6111.72784/tg+0.15215*log(tg))
+    ! ori          end if
+    ! ori          qg=eps*es/(p(i,icb(i))-es*(1.-eps))
+    qg = eps * es / (p(i, icb(i) + 1) - es * (1. - eps))
+
+    alv = lv0 - clmcpv * (ticb(i) - 273.15)
+
+    ! ori c approximation here:
+    ! ori         tp(i,icb(i))=(ah0(i)-(cl-cpd)*qnk(i)*ticb(i)
+    ! ori     &   -gz(i,icb(i))-alv*qg)/cpd
+
+    ! convect3: no approximation:
+    tp(i, icb(i) + 1) = (ah0(i) - gz(i, icb(i) + 1) - alv * qg) / (cpd + (cl - cpd) * qnk(i))
+
+    ! ori         clw(i,icb(i))=qnk(i)-qg
+    ! ori         clw(i,icb(i))=max(0.0,clw(i,icb(i)))
+    clw(i, icb(i) + 1) = qnk(i) - qg
+    clw(i, icb(i) + 1) = max(0.0, clw(i, icb(i) + 1))
+
+    rg = qg / (1. - qnk(i))
+    ! ori         tvp(i,icb(i))=tp(i,icb(i))*(1.+rg*epsi)
+    ! convect3: (qg utilise au lieu du vrai mixing ratio rg)
+    tvp(i, icb(i) + 1) = tp(i, icb(i) + 1) * (1. + qg / eps - qnk(i))     !whole thing
+
+  END DO
 
 END SUBROUTINE cv3_undilute1
 
 SUBROUTINE cv3_trigger(len, nd, icb, plcl, p, th, tv, tvp, thnk, &
-                       pbase, buoybase, iflag, sig, w0)
+        pbase, buoybase, iflag, sig, w0)
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
-! -------------------------------------------------------------------
-! --- TRIGGERING
-
-! - computes the cloud base
-! - triggering (crude in this version)
-! - relaxation of sig and w0 when no convection
-
-! Caution1: if no convection, we set iflag=14
-! (it used to be 0 in convect3)
-
-! Caution2: at this stage, tvp (and thus buoy) are know up
-! through icb only!
-! -> the buoyancy below cloud base not (yet) set to the cloud base buoyancy
-! -------------------------------------------------------------------
-
-  include "cv3param.h"
-
-! input:
+  ! -------------------------------------------------------------------
+  ! --- TRIGGERING
+
+  ! - computes the cloud base
+  ! - triggering (crude in this version)
+  ! - relaxation of sig and w0 when no convection
+
+  ! Caution1: if no convection, we set iflag=14
+  ! (it used to be 0 in convect3)
+
+  ! Caution2: at this stage, tvp (and thus buoy) are know up
+  ! through icb only!
+  ! -> the buoyancy below cloud base not (yet) set to the cloud base buoyancy
+  ! -------------------------------------------------------------------
+
+  ! input:
   INTEGER len, nd
   INTEGER icb(len)
@@ -906,55 +896,55 @@
   REAL thnk(len)
 
-! output:
+  ! output:
   REAL pbase(len), buoybase(len)
 
-! input AND output:
+  ! input AND output:
   INTEGER iflag(len)
   REAL sig(len, nd), w0(len, nd)
 
-! local variables:
+  ! local variables:
   INTEGER i, k
   REAL tvpbase, tvbase, tdif, ath, ath1
 
 
-! ***   set cloud base buoyancy at (plcl+dpbase) level buoyancy
+  ! ***   set cloud base buoyancy at (plcl+dpbase) level buoyancy
 
   DO i = 1, len
     pbase(i) = plcl(i) + dpbase
-    tvpbase = tvp(i, icb(i))  *(pbase(i)-p(i,icb(i)+1))/(p(i,icb(i))-p(i,icb(i)+1)) + &
-              tvp(i, icb(i)+1)*(p(i,icb(i))-pbase(i))  /(p(i,icb(i))-p(i,icb(i)+1))
-    tvbase = tv(i, icb(i))  *(pbase(i)-p(i,icb(i)+1))/(p(i,icb(i))-p(i,icb(i)+1)) + &
-             tv(i, icb(i)+1)*(p(i,icb(i))-pbase(i))  /(p(i,icb(i))-p(i,icb(i)+1))
+    tvpbase = tvp(i, icb(i)) * (pbase(i) - p(i, icb(i) + 1)) / (p(i, icb(i)) - p(i, icb(i) + 1)) + &
+            tvp(i, icb(i) + 1) * (p(i, icb(i)) - pbase(i)) / (p(i, icb(i)) - p(i, icb(i) + 1))
+    tvbase = tv(i, icb(i)) * (pbase(i) - p(i, icb(i) + 1)) / (p(i, icb(i)) - p(i, icb(i) + 1)) + &
+            tv(i, icb(i) + 1) * (p(i, icb(i)) - pbase(i)) / (p(i, icb(i)) - p(i, icb(i) + 1))
     buoybase(i) = tvpbase - tvbase
   END DO
 
 
-! ***   make sure that column is dry adiabatic between the surface  ***
-! ***    and cloud base, and that lifted air is positively buoyant  ***
-! ***                         at cloud base                         ***
-! ***       if not, return to calling program after resetting       ***
-! ***                        sig(i) and w0(i)                       ***
-
-
-! oct3      do 200 i=1,len
-! oct3
-! oct3       tdif = buoybase(i)
-! oct3       ath1 = th(i,1)
-! oct3       ath  = th(i,icb(i)-1) - dttrig
-! oct3
-! oct3       if (tdif.lt.dtcrit .OR. ath.gt.ath1) THEN
-! oct3         do 60 k=1,nl
-! oct3            sig(i,k) = beta*sig(i,k) - 2.*alpha*tdif*tdif
-! oct3            sig(i,k) = AMAX1(sig(i,k),0.0)
-! oct3            w0(i,k)  = beta*w0(i,k)
-! oct3   60    continue
-! oct3         iflag(i)=4 ! pour version vectorisee
-! oct3c convect3         iflag(i)=0
-! oct3cccc         RETURN
-! oct3       endif
-! oct3
-! oct3200   continue
-
-! -- oct3: on reecrit la boucle 200 (pour la vectorisation)
+  ! ***   make sure that column is dry adiabatic between the surface  ***
+  ! ***    and cloud base, and that lifted air is positively buoyant  ***
+  ! ***                         at cloud base                         ***
+  ! ***       if not, return to calling program after resetting       ***
+  ! ***                        sig(i) and w0(i)                       ***
+
+
+  ! oct3      do 200 i=1,len
+  ! oct3
+  ! oct3       tdif = buoybase(i)
+  ! oct3       ath1 = th(i,1)
+  ! oct3       ath  = th(i,icb(i)-1) - dttrig
+  ! oct3
+  ! oct3       if (tdif.lt.dtcrit .OR. ath.gt.ath1) THEN
+  ! oct3         do 60 k=1,nl
+  ! oct3            sig(i,k) = beta*sig(i,k) - 2.*alpha*tdif*tdif
+  ! oct3            sig(i,k) = AMAX1(sig(i,k),0.0)
+  ! oct3            w0(i,k)  = beta*w0(i,k)
+  ! oct3   60    continue
+  ! oct3         iflag(i)=4 ! pour version vectorisee
+  ! oct3c convect3         iflag(i)=0
+  ! oct3cccc         RETURN
+  ! oct3       endif
+  ! oct3
+  ! oct3200   continue
+
+  ! -- oct3: on reecrit la boucle 200 (pour la vectorisation)
 
   DO k = 1, nl
@@ -963,12 +953,12 @@
       tdif = buoybase(i)
       ath1 = thnk(i)
-      ath = th(i, icb(i)-1) - dttrig
+      ath = th(i, icb(i) - 1) - dttrig
 
       IF (tdif<dtcrit .OR. ath>ath1) THEN
-        sig(i, k) = beta*sig(i, k) - 2.*alpha*tdif*tdif
-        sig(i, k) = amax1(sig(i,k), 0.0)
-        w0(i, k) = beta*w0(i, k)
+        sig(i, k) = beta * sig(i, k) - 2. * alpha * tdif * tdif
+        sig(i, k) = amax1(sig(i, k), 0.0)
+        w0(i, k) = beta * w0(i, k)
         iflag(i) = 14 ! pour version vectorisee
-! convect3         iflag(i)=0
+        ! convect3         iflag(i)=0
       END IF
 
@@ -976,29 +966,28 @@
   END DO
 
-! fin oct3 --
-
+  ! fin oct3 --
 
 END SUBROUTINE cv3_trigger
 
 SUBROUTINE cv3_compress(len, nloc, ncum, nd, ntra, &
-                        iflag1, nk1, icb1, icbs1, &
-                        plcl1, tnk1, qnk1, gznk1, pbase1, buoybase1, &
-                        t1, q1, qs1, u1, v1, gz1, th1, &
-                        tra1, &
-                        h1, lv1, cpn1, p1, ph1, tv1, tp1, tvp1, clw1, &
-                        sig1, w01, &
-                        iflag, nk, icb, icbs, &
-                        plcl, tnk, qnk, gznk, pbase, buoybase, &
-                        t, q, qs, u, v, gz, th, &
-                        tra, &
-                        h, lv, cpn, p, ph, tv, tp, tvp, clw, &
-                        sig, w0)
+        iflag1, nk1, icb1, icbs1, &
+        plcl1, tnk1, qnk1, gznk1, pbase1, buoybase1, &
+        t1, q1, qs1, u1, v1, gz1, th1, &
+        tra1, &
+        h1, lv1, cpn1, p1, ph1, tv1, tp1, tvp1, clw1, &
+        sig1, w01, &
+        iflag, nk, icb, icbs, &
+        plcl, tnk, qnk, gznk, pbase, buoybase, &
+        t, q, qs, u, v, gz, th, &
+        tra, &
+        h, lv, cpn, p, ph, tv, tp, tvp, clw, &
+        sig, w0)
   USE lmdz_print_control, ONLY: lunout
   USE lmdz_abort_physic, ONLY: abort_physic
+  USE lmdz_cv3param
+
   IMPLICIT NONE
 
-  include "cv3param.h"
-
-!inputs:
+  !inputs:
   INTEGER len, ncum, nd, ntra, nloc
   INTEGER iflag1(len), nk1(len), icb1(len), icbs1(len)
@@ -1007,5 +996,5 @@
   REAL t1(len, nd), q1(len, nd), qs1(len, nd), u1(len, nd), v1(len, nd)
   REAL gz1(len, nd), h1(len, nd), lv1(len, nd), cpn1(len, nd)
-  REAL p1(len, nd), ph1(len, nd+1), tv1(len, nd), tp1(len, nd)
+  REAL p1(len, nd), ph1(len, nd + 1), tv1(len, nd), tp1(len, nd)
   REAL tvp1(len, nd), clw1(len, nd)
   REAL th1(len, nd)
@@ -1013,6 +1002,6 @@
   REAL tra1(len, nd, ntra)
 
-!outputs:
-! en fait, on a nloc=len pour l'instant (cf cv_driver)
+  !outputs:
+  ! en fait, on a nloc=len pour l'instant (cf cv_driver)
   INTEGER iflag(nloc), nk(nloc), icb(nloc), icbs(nloc)
   REAL plcl(nloc), tnk(nloc), qnk(nloc), gznk(nloc)
@@ -1020,5 +1009,5 @@
   REAL t(nloc, nd), q(nloc, nd), qs(nloc, nd), u(nloc, nd), v(nloc, nd)
   REAL gz(nloc, nd), h(nloc, nd), lv(nloc, nd), cpn(nloc, nd)
-  REAL p(nloc, nd), ph(nloc, nd+1), tv(nloc, nd), tp(nloc, nd)
+  REAL p(nloc, nd), ph(nloc, nd + 1), tv(nloc, nd), tp(nloc, nd)
   REAL tvp(nloc, nd), clw(nloc, nd)
   REAL th(nloc, nd)
@@ -1026,9 +1015,9 @@
   REAL tra(nloc, nd, ntra)
 
-!local variables:
+  !local variables:
   INTEGER i, k, nn, j
 
-  CHARACTER (LEN=20) :: modname = 'cv3_compress'
-  CHARACTER (LEN=80) :: abort_message
+  CHARACTER (LEN = 20) :: modname = 'cv3_compress'
+  CHARACTER (LEN = 80) :: abort_message
 
   DO k = 1, nl + 1
@@ -1059,16 +1048,16 @@
   END DO
 
-!AC!      do 121 j=1,ntra
-!AC!ccccc      do 111 k=1,nl+1
-!AC!      do 111 k=1,nd
-!AC!       nn=0
-!AC!      do 101 i=1,len
-!AC!      IF(iflag1(i).EQ.0)THEN
-!AC!       nn=nn+1
-!AC!       tra(nn,k,j)=tra1(i,k,j)
-!AC!      endif
-!AC! 101  continue
-!AC! 111  continue
-!AC! 121  continue
+  !AC!      do 121 j=1,ntra
+  !AC!ccccc      do 111 k=1,nl+1
+  !AC!      do 111 k=1,nd
+  !AC!       nn=0
+  !AC!      do 101 i=1,len
+  !AC!      IF(iflag1(i).EQ.0)THEN
+  !AC!       nn=nn+1
+  !AC!       tra(nn,k,j)=tra1(i,k,j)
+  !AC!      endif
+  !AC! 101  continue
+  !AC! 111  continue
+  !AC! 121  continue
 
   IF (nn/=ncum) THEN
@@ -1095,5 +1084,4 @@
   END DO
 
-
 END SUBROUTINE cv3_compress
 
@@ -1102,7 +1090,7 @@
 
 
-!JAM--------------------------------------------------------------------
-! Calcul de la quantité d'eau sous forme de glace
-! --------------------------------------------------------------------
+  !JAM--------------------------------------------------------------------
+  ! Calcul de la quantité d'eau sous forme de glace
+  ! --------------------------------------------------------------------
   INTEGER nl, len
   REAL qi(len, nl)
